
  /**
   * iTunesController v0.1.1
   * (c) 2006 Ricardo Martinez
   * 
   * iTunes(R) is a registered trademark of Apple Computer, Inc.,
   * registered in the U.S. and other countries.
   */
     
  var iTunes, iTunesApp, lastLocation, changeCheckTimer;
  
  function start()
  { 
    try {
      iTunesApp = new ActiveXObject("iTunes.Application");
    } catch(e) {
      window.setTimeout(start, 5000);
      return;
    }
    
    updatePlayPauseButton();
    if (iTunesApp.currentTrack)
    {
      updateTrack();
      updateArtwork();
    } else {
      clear();
      title.innerText = "Nothing playing...";
    }
    changeCheckTimer = window.setInterval(changeCheck, 500);
  }
  
  function updateArtwork()
  {
    if ( iTunesApp.CurrentTrack.Artwork.Count > 0 )
    {
      var path = new String(System.Gadget.path + "\\temp.jpg");
      path = path.replace("\\", "\\\\");
      
      iTunesApp.CurrentTrack.Artwork.Item(1).SaveArtworkToFile(path);
      artwork.filters.item(0).Apply();
      artwork.filters.item(1).src = path + "?" + new Date();
      artwork.filters.item(0).Play();
    } else {
      artwork.filters.item(0).Apply();
      artwork.filters.item(1).src = "images/blank.png";
      artwork.filters.item(0).Play();
    }
  }
  
  function updateTrack()
  {
    var currentTrack = iTunesApp.currentTrack;
    artist.innerText = currentTrack.Artist;
    title.innerText  = currentTrack.Name;
    album.innerText  = currentTrack.Album;
    lastLocation = currentTrack.Location;
  }
  
  function changeCheck()
  {
    if (iTunesApp)
    {
      try {
        if (iTunesApp.currentTrack)
        {
          var currentTrack = iTunesApp.currentTrack;
          if ( currentTrack.Location != lastLocation )
          {
            updateTrack();
            updateArtwork();
          }
          updateTime();
        } else {
          clear();
          title.innerText = "Nothing playing...";
        }
      } catch(e) {
        // Need to find a way to find out if iTunes
        // is unresponsive because of a dialog box
        // or because it has been closed...
      }
    } else {
      start();
    }
  }
  
  function iTunesClosed()
  {
    clear();
    title.innerText = "iTunes has been closed";
    artist.innerHTML = '<a href="javascript:start();">Reopen iTunes</a>';
    window.clearInterval(changeCheckTimer);
  }
  
  function clear()
  {
    currentPosition.innerText = "";
    songDuration.innerText = "";
    title.innerText = "";
    artist.innerText = "";
    album.innerText = "";
    artwork.filters.item(1).src = "images/blank.png";
  }
  
  function updateTime()
  {
    var cur = iTunesApp.PlayerPosition;
    var len = iTunesApp.currentTrack.Duration;
    currentPosition.innerText = secsToTime(cur);
    songDuration.innerText = secsToTime(len);
  }
  
  function secsToTime(secs)
  {
    var hours = parseInt(secs / 3600);
    var mins = parseInt((secs / 60) - (hours * 60));
    var secs = secs - (mins * 60) - (hours * 3600);
    
    if ( hours > 0 && mins < 10 ) mins = "0" + mins;
    if ( secs < 10 ) secs = "0" + secs;
    
    if ( hours == 0 ) {
      return mins + ":" + secs;
    } else {
      return hours + ":" + mins + ":" + secs;
    }
  }
  
  function playPause()
  {
    try {
      iTunesApp.PlayPause();
      updatePlayPauseButton();
    } catch(e) {}
  }
  
  function updatePlayPauseButton()
  {
    if ( iTunesApp.PlayerState == 1 ) {
      playPauseButton.src = "images/button_pause.png";
    } else {
      playPauseButton.src = "images/button_play.png";
    }
  }
  
  function next()
  {
    try {
    iTunesApp.NextTrack();
    } catch(e) {}
  }
  
  function previous()
  {
    try {
    iTunesApp.PreviousTrack();
    } catch(e) {}
  }